Imports System.CodeDom.Compiler
Imports System.Text
Imports CodeGenSample
Imports System.Windows.Forms
Public Class frmImmediateSnippet
    Inherits System.Windows.Forms.Form
    Private m_Errors() As CompilerError
    Private m_SourceCode As String
    Private m_Exception As Exception
    Private m_language As CompileEngine.languagetype
    Public Sub New(ByVal errors As Object(), ByVal sourcecode As String, ByVal exception As Exception, ByVal language As Integer)
        MyBase.New()
        'This call is required by the Windows Form Designer.
        InitializeComponent()
        ' txtCode.Text = sourcecode
        m_Errors = CType(errors, CompilerError())
        m_SourceCode = sourcecode
        m_Exception = exception

        m_language = CType(language, CompileEngine.languagetype)
    End Sub

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents txtCode As System.Windows.Forms.TextBox
    Friend WithEvents cmdRun As System.Windows.Forms.Button
    Friend WithEvents lstErrors As System.Windows.Forms.ListBox
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents cmdClose As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(frmImmediateSnippet))
        Me.txtCode = New System.Windows.Forms.TextBox
        Me.cmdRun = New System.Windows.Forms.Button
        Me.lstErrors = New System.Windows.Forms.ListBox
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.cmdClose = New System.Windows.Forms.Button
        Me.Panel1.SuspendLayout()
        Me.SuspendLayout()
        '
        'txtCode
        '
        Me.txtCode.Dock = System.Windows.Forms.DockStyle.Fill
        Me.txtCode.Font = New System.Drawing.Font("Lucida Console", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtCode.Location = New System.Drawing.Point(0, 51)
        Me.txtCode.Multiline = True
        Me.txtCode.Name = "txtCode"
        Me.txtCode.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtCode.Size = New System.Drawing.Size(582, 197)
        Me.txtCode.TabIndex = 0
        Me.txtCode.Text = ""
        '
        'cmdRun
        '
        Me.cmdRun.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdRun.Location = New System.Drawing.Point(14, 13)
        Me.cmdRun.Name = "cmdRun"
        Me.cmdRun.TabIndex = 1
        Me.cmdRun.Text = "Run"
        '
        'lstErrors
        '
        Me.lstErrors.Dock = System.Windows.Forms.DockStyle.Bottom
        Me.lstErrors.Font = New System.Drawing.Font("Lucida Console", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lstErrors.Location = New System.Drawing.Point(0, 248)
        Me.lstErrors.Name = "lstErrors"
        Me.lstErrors.Size = New System.Drawing.Size(582, 95)
        Me.lstErrors.TabIndex = 2
        '
        'Panel1
        '
        Me.Panel1.Controls.Add(Me.cmdClose)
        Me.Panel1.Controls.Add(Me.cmdRun)
        Me.Panel1.Dock = System.Windows.Forms.DockStyle.Top
        Me.Panel1.Location = New System.Drawing.Point(0, 0)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(582, 51)
        Me.Panel1.TabIndex = 3
        '
        'cmdClose
        '
        Me.cmdClose.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.cmdClose.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdClose.Location = New System.Drawing.Point(502, 14)
        Me.cmdClose.Name = "cmdClose"
        Me.cmdClose.TabIndex = 2
        Me.cmdClose.Text = "Close"
        '
        'frmImmediateSnippet
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(582, 343)
        Me.Controls.Add(Me.txtCode)
        Me.Controls.Add(Me.lstErrors)
        Me.Controls.Add(Me.Panel1)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "frmImmediateSnippet"
        Me.Text = "Errors"
        Me.Panel1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Errors_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        UpDateForm()
    End Sub
    Public Sub UpDateForm()

        Dim c As CompilerError
        Dim sb As New StringBuilder
        lstErrors.Items.Clear()
        If Not m_Errors Is Nothing Then
            For Each c In m_Errors
                lstErrors.Items.Add(String.Format("{0}({1}): {2} {3}", c.Line, c.Column, c.ErrorNumber, c.ErrorText))

                'sb.AppendFormat("{0}({1}): {2} {3}{4}", c.Line, c.Column, c.ErrorNumber, c.ErrorText, vbCrLf)

            Next
        End If
        'Return sb.ToString()
        txtCode.Text = m_SourceCode
        If Not m_Exception Is Nothing Then
            MessageBox.Show(m_Exception.ToString, "Exception!")
        End If
    End Sub

    Private Sub lstErrors_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstErrors.Click

    End Sub

    Private Sub cmdRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRun.Click
        Dim t As New Threading.Thread(AddressOf RunTheProg)
        t.Start()

    End Sub



    Private Sub RunTheProg()

        Dim code As String = txtCode.Text.Trim()
        Dim entry As String '= txtEntry.Text.Trim();

        If (code = "") Then Return

        If (entry = "") Then entry = "Main"

        Dim engine As CompileEngine = New CompileEngine(code, m_language, entry)


        m_Errors = engine.Run()
        m_SourceCode = engine.sourceCode
        If Not engine.Exception Is Nothing Then
            m_Exception = engine.Exception
            If Not m_Exception.InnerException Is Nothing Then
                m_Exception = m_Exception.InnerException
            End If
        Else
            m_Exception = Nothing
        End If


        UpDateForm()

    End Sub

    Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
        Me.Close()
    End Sub
End Class
